/* fester */

#include <stdio.h>

typedef struct
{
  long offset;
  char *from;
  char *to;
  int length;
} mod;

/* length is included because we don't necessarily only want to write
   <strlen> bytes (ie, we might want to write the terminating NULL too).*/

mod xf86quakeMods[] = 
{
  0x36768, "/raid/quake", ".", 2,
  0x33148, "/qcache", "qcache/", 7,
  0, NULL, NULL, 0
};

mod xquakeMods[] = 
{
  0x35378, "/raid/quake", ".", 2,
  0x31D58, "/qcache", "qcache/", 7,
  0, NULL, NULL, 0
};

int trymods( mod *mods, char *file );
int main(int argc, char **argv)
{
  int i;
  if(argc < 2)
  {
    fprintf(stderr, "Like this:  \"fester <executable> ...\"\n");
    exit(1);
  }

  for(i=1;i<argc;i++)
  {
    if(trymods(xf86quakeMods, argv[i]));
    trymods(xquakeMods, argv[i]);
  }
  exit(0);
}

int trymods( mod *mods, char *file )
{
  FILE *fp = NULL;
  int result = 1;
  int goodfile = 1;
  int i;
  char *buf = NULL;

  fp = fopen(file, "r+");
  if(!fp)
  {
    perror(file);
    return 0;
  }

  /* make sure it's the right file before making any changes */

  for(i=0;mods[i].to;i++)
  {
    int length = strlen(mods[i].from);
    buf = (char *)malloc(length+1);

    if(fseek(fp, mods[i].offset, SEEK_SET))
    {
      goodfile = 0;
      break;
    }
    if(fread(buf, 1, length, fp) < length)
    {
      goodfile = 0;
      break;
    }
    *(buf+length) = 0;
    if(strcmp(buf, mods[i].from))
    {
      goodfile = 0;
      break;
    }
    free(buf);
  }
  if(buf) free(buf);

  if(!goodfile)
    result = 1;
  else
  {
    for(i=0;mods[i].to;i++)
    {
      if(fseek(fp, mods[i].offset, SEEK_SET))
      {
        goodfile = 0;
        break;
      }
      if(fwrite(mods[i].to, 1, mods[i].length, fp) < mods[i].length)
      {
        goodfile = 0;
        break;
      }
    }
    if(goodfile)
    {
      result = 0;
      fprintf(stdout, "Patched %s ok.\n", file);
    }
    else
    {
      result = 1;
      fprintf(stderr, "Write error patching %s.\n", file);
    }
  }

  fclose(fp);
  return result;
}
